<?php

namespace FiloBlu\AdvancedCustomOptions\Block\Product\View\Options\Type;

use FiloBlu\AdvancedCustomOptions\Block\Product\View\Options\Type\Image\ImageSelectorFactory;
use FiloBlu\AdvancedCustomOptions\Model\Product\Option;
use Magento\Catalog\Block\Product\View\Options\AbstractOptions;
use Magento\Catalog\Helper\Data as CatalogHelper;
use Magento\Framework\App\ObjectManager;
use Magento\Framework\Pricing\Helper\Data;
use Magento\Framework\View\Element\Template\Context;

/**
 * Class Image
 * @package FiloBlu\AdvancedCustomOptions\Block\Product\View\Options\Type
 */
class Image extends AbstractOptions
{

    /**
     * @var mixed
     */
    private $imageSelectorFactory;

    /**
     * Image constructor.
     * @param Context $context
     * @param Data $pricingHelper
     * @param CatalogHelper $catalogData
     * @param array $data
     * @param ImageSelectorFactory|null $imageSelectorFactory
     */
    public function __construct(
        Context $context,
        Data $pricingHelper,
        CatalogHelper $catalogData,
        array $data = [],
        ImageSelectorFactory $imageSelectorFactory = null
    ) {
        parent::__construct($context, $pricingHelper, $catalogData, $data);
        $this->imageSelectorFactory = $imageSelectorFactory ?: ObjectManager::getInstance()->get(ImageSelectorFactory::class);
    }

    /**
     * Return html for control element
     *
     * @return string
     */
    public function getValuesHtml()
    {
        $option = $this->getOption();
        $optionType = $option->getType();
        if ($optionType === Option::OPTION_TYPE_OPTION_IMAGE) {
            $optionBlock = $this->imageSelectorFactory->create();
        }
        return $optionBlock
            ->setOption($option)
            ->setProduct($this->getProduct())
            ->setSkipJsReloadPrice(1)
            ->_toHtml();
    }
}
