<?php

namespace FiloBlu\AdvancedCustomOptions\Controller\Adminhtml\Product;

use Exception;
use Magento\Backend\App\Action;
use Magento\Backend\App\Action\Context;
use Magento\Catalog\Model\ImageUploader;
use Magento\Framework\App\ResponseInterface;
use Magento\Framework\Controller\ResultFactory;
use Magento\Framework\Controller\ResultInterface;

/**
 * Class Preview
 * @package FiloBlu\AdvancedCustomOptions\Controller\Adminhtml\Product
 */
class Preview extends Action
{
    /**
     * @var string
     */
    const ACTION_RESOURCE = 'FiloBlu_AdvancedCustomOptions::image';

    /**
     * @var ImageUploader
     */
    protected $imageUploader;

    /**
     * Preview constructor.
     *
     * @param Context $context
     * @param ImageUploader $imageUploader
     */
    public function __construct(
        Context $context,
        ImageUploader $imageUploader
    ) {
        $this->imageUploader = $imageUploader;
        parent::__construct($context);
    }

    /**
     * Execute
     *
     * @return ResponseInterface|ResultInterface
     */
    public function execute()
    {
        $name = $this->getFieldName();

        try {
            $result = $this->imageUploader->saveFileToTmpDir($_FILES[$name]);
        } catch (Exception $e) {
            $result = [
                'error' => $e->getMessage(),
                'errorcode' => $e->getCode()
            ];
        }
        return $this->resultFactory->create(ResultFactory::TYPE_JSON)->setData($result);
    }

    /**
     * @return string
     */
    protected function getFieldName()
    {
        return $this->_request->getParam('field');
    }
}
