<?php
/**
 * Copyright © Magento, Inc. All rights reserved.
 * See COPYING.txt for license details.
 */

namespace FiloBlu\AdvancedCustomOptions\Model\Product;

use Magento\Catalog\Model\Product;

/**
 * Class Option
 * @package FiloBlu\AdvancedCustomOptions\Model\Product
 */
class Option extends Product\Option
{
    const OPTION_TYPE_OPTION_IMAGE = 'option_image';
    const OPTION_GROUP_IMAGE = 'image';

    /**
     * @param null $type
     * @return bool
     */
    public function hasValues($type = null)
    {
        return in_array($this->getGroupByType($type), [self::OPTION_GROUP_SELECT, self::OPTION_GROUP_IMAGE]);
    }

    /**
     * Get group name of option by given option type
     *
     * @param string $type
     * @return string
     */
    public function getGroupByType($type = null)
    {
        if ($type === null) {
            $type = $this->getType();
        }
        $optionGroupsToTypes = [
            self::OPTION_TYPE_FIELD => self::OPTION_GROUP_TEXT,
            self::OPTION_TYPE_AREA => self::OPTION_GROUP_TEXT,
            self::OPTION_TYPE_FILE => self::OPTION_GROUP_FILE,
            self::OPTION_TYPE_DROP_DOWN => self::OPTION_GROUP_SELECT,
            self::OPTION_TYPE_RADIO => self::OPTION_GROUP_SELECT,
            self::OPTION_TYPE_CHECKBOX => self::OPTION_GROUP_SELECT,
            self::OPTION_TYPE_MULTIPLE => self::OPTION_GROUP_SELECT,
            self::OPTION_TYPE_DATE => self::OPTION_GROUP_DATE,
            self::OPTION_TYPE_DATE_TIME => self::OPTION_GROUP_DATE,
            self::OPTION_TYPE_TIME => self::OPTION_GROUP_DATE,
            self::OPTION_TYPE_OPTION_IMAGE => self::OPTION_GROUP_IMAGE
        ];

        return $optionGroupsToTypes[$type] ?? '';
    }
}
