<?php

namespace FiloBlu\AdvancedCustomOptions\Model\ResourceModel\Product;

use FiloBlu\AdvancedCustomOptions\Ui\DataProvider\Catalog\Product\Form\Modifier\CustomOptions;
use Magento\Framework\Model\AbstractModel;
use Magento\Framework\Model\ResourceModel\Db\AbstractDb;
use Magento\Store\Model\Store;

/**
 * Class Option
 * @package FiloBlu\AdvancedCustomOptions\Model\ResourceModel\Product
 */
class Option extends \Magento\Catalog\Model\ResourceModel\Product\Option
{

    /**
     * @param AbstractModel $object
     * @return AbstractDb
     */
    protected function _afterSave(AbstractModel $object)
    {
        //WE NEED TO CATCH AND MANAGE THE CASE FOR OPTION IMAGE IN ORDER TO SAVE THE VALUES CORRECTLY
        if (in_array($object->getType(), [CustomOptions::FIELD_OPTION_IMAGE_NAME])) {
            if ($object->getFilobluCustomImage() !== null) {
                $object->setData('values', $object->getFilobluCustomImage());
            }
        }

        return parent::_afterSave($object);
    }

}
