<?php

namespace FiloBlu\AdvancedCustomOptions\Model\ResourceModel\Product\Option;

use Magento\Catalog\Api\Data\ProductCustomOptionInterface;
use Magento\Framework\Api\ExtensionAttribute\JoinProcessorInterface;
use Magento\Framework\App\ObjectManager;
use Magento\Framework\DataObject;
use Magento\Framework\Exception\NoSuchEntityException;
use Magento\Store\Model\Store;

/**
 * Class Collection
 * @package FiloBlu\AdvancedCustomOptions\Model\ResourceModel\Product\Option
 */
class Collection extends \Magento\Catalog\Model\ResourceModel\Product\Option\Collection
{

    /**
     * @param null $storeId
     * @return $this|\Magento\Catalog\Model\ResourceModel\Product\Option\Collection
     * @throws NoSuchEntityException
     */
    public function addValuesToResult($storeId = null)
    {
        if ($storeId === null) {
            $storeId = $this->_storeManager->getStore()->getId();
        }
        $optionIds = [];
        foreach ($this as $option) {
            $optionIds[] = $option->getId();
        }
        if (!empty($optionIds)) {
            /** @var \Magento\Catalog\Model\ResourceModel\Product\Option\Value\Collection $values */
            $values = $this->_optionValueCollectionFactory->create();
            $values->addTitleToResult(
                $storeId
            )->addPriceToResult(
                $storeId
            )->addImageToResult(
                $storeId
            )->addSalableToResult(
                $storeId
            )->addDefaultToResult(
                $storeId
            )->addOptionToFilter(
                $optionIds
            )->setOrder(
                'sort_order',
                self::SORT_ORDER_ASC
            )->setOrder(
                'title',
                self::SORT_ORDER_ASC
            );

            foreach ($values as $value) {
                $optionId = $value->getOptionId();
                if ($this->getItemById($optionId)) {
                    $this->getItemById($optionId)->addValue($value);
                    $value->setOption($this->getItemById($optionId));
                }
            }
        }

        return $this;
    }

}
